<template>
    <div class="w-full flex flex-col">
        <div class="flex flex-col m-2 bg-gray-200 p-2 w-full">
            <div class="w-full bg-white">
                <table class="relative table-auto w-full">
                    <thead>
                        <tr class="border-b border-gray-200">
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Name</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Rank</th>
                            <th class="px-2 py-2 bg-gray-50 text-center text-xs font-medium text-gray-500 uppercase">Actions</th>
                        </tr>
                    </thead>
                    <tbody class="bg-white overflow-y-auto w-full">
                        <tr v-for="u in users" :key="u.id">
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <div class="text-sm leading-5 text-gray-700 whitespace-pre-line w-full"><a :href="u.profile">{{u.first}} {{u.last}}</a></div>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <v-select label="name" :options="ranks" :reduce="a => a.id" v-model="u.rank" class="w-full"></v-select>
                            </td>
                            <td class="px-2 py-2 whitespace-no-wrap">
                                <button class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="save(u)">
                                    <img svg-inline src="./pix/zond/save-disk.svg" class="w-4 h-4 fill-current" />
                                </button>
                                <button class="font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="remove(u)">
                                    <img svg-inline src="./pix/zond/trash.svg" class="w-4 h-4 fill-current" />
                                </button>
                            </td>
                        </tr>
                    </tbody>
                </table>
            </div>
        </div>
    </div>
</template>
<script>
import Vue from 'vue'
import axios from 'axios'
import vSelect from 'vue-select'
import WeeUsersAutocomplete from './WeeUsersAutocomplete'
import 'vue-select/dist/vue-select.css';

Vue.component('v-select', vSelect);

export default {
    name: "WeeUsers",
    props: [],
    data(){
        return {
            users: [],
            ranks: []
        };
    },
    components: {
    },
    created(){
        this.load();
    },
    methods: {
        load(){
            let self = this;
            axios.get(this.usersUrl).then(function(response){
                self.users = response.data.users.map(function(u){
                    u.profile = '/user/profile/'+u.id;
                    u.prerank = u.rank;
                    return u;
                });
                self.ranks = response.data.ranks;
            }).catch(function(error){
                console.log(error);
            });
        },
        save(u){
            let self = this;
            axios.post(this.saveUrl+u.id+'/'+u.rank, {}).then(function(response){
                if(response.data.success){
                    
                }
            }).catch(function(error){
                console.log(error);
            });
        }
    },
    computed: {
        usersUrl(){
            return '/admin/users/fetch';
        },
        saveUrl(){
            return '/admin/users/save/';
        }
    }
}
</script>
<style>

</style>
